function loadsettings() {
	fullscreen(false);

	var settings = document.getElementsByClassName('setting');
	for(var i = 0; i < settings.length;) {
		if(!('global' in settings[i].dataset)) {
			settings[i].remove();
		} else {
			i++;
		}
	}

	var cvs = availvis[curvis].settings; //Current Visual Settings
	for(var k of Object.keys(cvs)) {
		var sel = document.createElement('div'), val = document.createElement('div'), skip = false;
		sel.className = 'setting';
		sel.tabIndex = -1;
		val.className = 'settingValue';

		switch(typeof(cvs[k])) {
			case 'boolean': 
				sel.setAttribute('data-settingtype','boolean'); 
				val.textContent = cosmetic.toUpper(cvs[k]); // unnecessarily complex
				break;
			case 'number': 
				sel.setAttribute('data-settingtype','number');
				val.textContent = cvs[k];
				break;
			default: skip = true; break;
		}

		if(!skip) {
			sel.setAttribute('data-setting',k);
			sel.textContent = availvis[curvis].settingsName[k];
			sel.appendChild(val);
			document.getElementById('settings').appendChild(sel);
		}
	}

	//global settings
	document.getElementsByClassName('settingValue')[0].innerHTML = '<div style="background: ' + vmc.globalSettings.color + '" class="settingValueColor">';
	document.getElementsByClassName('settingValue')[1].innerHTML = '<div style="background: ' + vmc.globalSettings.bgColor + '" class="settingValueColor">';
	document.getElementsByClassName('settingValue')[2].textContent = vmc.globalSettings.smooth;

	settingsKsel = 0;
	curpage = 2;
	//document.getElementsByClassName('setting')[0].focus();
	//updatenavbar();

	setTimeout(function(){
		document.getElementsByClassName('setting')[0].focus();
		updatenavbar();
	},0);
	document.getElementById('settings').style.display = null;
	//document.body.classList.add('darker');
}

var settingsKsel = 0;
function settingsK(k) {
	var cvos = availvis[curvis], 
	acd = document.activeElement.dataset, 
	acot = document.activeElement.getElementsByClassName('settingValue')[0];
	/* cvos: current vis settings, acd: active dataset */

	switch(k.key) {
		case 'Enter':
			switch(acd.settingtype) {
				case 'boolean': settingsKboolch(); break; //function changes active element.
				case 'color': colorchange(); break;
			}
			break;
		case 'ArrowLeft': 
			switch(acd.settingtype) {
				case 'number': settingsKnumch(-1); break;
				case 'boolean': settingsKboolch(); break; //function changes active element.
			}
			break;
		case 'ArrowRight': 
		switch(acd.settingtype) {
			case 'number': settingsKnumch(1); break;
			case 'boolean': settingsKboolch(); break; //function changes active element.
		}
	break;
		case 'ArrowUp': k.preventDefault(); settingsKsel = navigatelist(settingsKsel,document.getElementsByClassName('setting'), -1); break;
		case 'ArrowDown': k.preventDefault(); settingsKsel = navigatelist(settingsKsel,document.getElementsByClassName('setting'),1); break;
		case 'Backspace':
		case 'SoftLeft':
			k.preventDefault();
			curpage = 0;
			//document.body.classList.remove('darker');
			document.getElementById('settings').style.display = 'none';
			break;
		}

		updatenavbar();
}
 
function settingsKnumch(change) {
	var sobj, srobj;
	if(document.activeElement.dataset.global) {
		sobj = vmc.globalSettings;
		srobj = vmc.globalSettingsRange,
		ssobj = vmc.globalSettingsStep || {};
	} else {
		sobj = availvis[curvis].settings;
		srobj = availvis[curvis].settingsRange,
		ssobj = availvis[curvis].settingsStep || {};
	}

	if(document.activeElement.dataset.setting in ssobj) {
		change = ssobj[document.activeElement.dataset.setting] * change;
	}

	if(
		srobj[document.activeElement.dataset.setting][0] <= sobj[document.activeElement.dataset.setting] + change &&
		srobj[document.activeElement.dataset.setting][1] >= sobj[document.activeElement.dataset.setting] + change
	) {
		sobj[document.activeElement.dataset.setting] += change;
	}
	document.activeElement.getElementsByClassName('settingValue')[0].textContent = sobj[document.activeElement.dataset.setting];
	
}

function settingsKboolch() {
	var cvos = availvis[curvis], 
	acd = document.activeElement.dataset, 
	acot = document.activeElement.getElementsByClassName('settingValue')[0];

	if(acd.global) {
		vmc.globalSettings[acd.setting] = !vmc.globalSettings[acd.setting];
		acot.textContent = cosmetic.toUpper(vmc.globalSettings[acd.setting]);
	} else {
		cvos.settings[acd.setting] = !cvos.settings[acd.setting];
		acot.textContent = cosmetic.toUpper(cvos.settings[acd.setting]);
	}	
}


var cosmetic = {
	toUpper: function(input) {return String(input).substr(0,1).toUpperCase() + String(input).substr(1);}
}

function settingsMemory(action) {
	switch(action) {
		case 'save':
			var settingsobj = {
				global: vmc.globalSettings,
				spec: []
			};
			for(var i = 0; i < availvis.length; i++) {settingsobj.spec.push(availvis[i].settings);}
			localStorage.setItem('settings',JSON.stringify(settingsobj));
			alertMessage('Settings saved!');
			break;
		case 'load':
			var settingsobj = localStorage.getItem('settings');
			if(settingsobj === null) {
				return;
			} else {
				settingsobj = JSON.parse(settingsobj);
			}
			vmc.globalSettings = settingsobj.global;
			for(var i = 0; i < availvis.length; i++) {
				var sts = Object.keys(settingsobj.spec[i]); //console.log(sts);
				for(var ii = 0; ii < sts.length; ii++) {
					if(Object.keys(availvis[i].settings).indexOf(sts[ii]) > -1) {
						//console.log(sts[ii]);
						availvis[i].settings[sts[ii]] = settingsobj.spec[i][sts[ii]];
					}
				}
				//availvis[i].settings = settingsobj.spec[i];
			}
			break;
		/* case 'delete':
			localStorage.removeItem('settings');
			alertMessage('Settings deleted!');
			break; */

	}
}