var navbar = {
    "myself": document.getElementById('navbar'),
    "left": document.getElementById('navbar-left'),
    "right": document.getElementById('navbar-right'),
    "center": document.getElementById('navbar-center')
};

function navigatelist(index,list,move,width) { //RETURNS the current index of the thing.
	var nindex;
	if(width === undefined) {
		nindex = navigatelistonly(index,list,move);
	} else {
		nindex = navigatelistvert(index,list,move,width);
	}
    list[nindex].focus();
    return nindex;
}

function navigatelistonly(index,list,move) {
    if(move > 0) { //going down
        if(index + 1 < list.length) {
            index++;
        } else {
            index = 0;
        }
    } else if(move < 0) {
        if(index - 1 > -1) {
            index--;
        } else {
            index = list.length - 1;
        }
    }
    return index;
}

function navigatelistvert(index,list,move,width) { //for moving in a grid
	var change;
	switch(move) { // [n / s / e / w]
		case 'n': change = -1; break;
		case 's': change = 1; break;
		default: return 0;
	}

	index += (change * width);
	if(!(index in list)) {
		index += ((change * -1) * list.length);
	}

	return index;
}



function rotate() {
	if('orientation' in screen) {
		if(screen.orientation.type.indexOf('portrait') === -1) {
			screen.orientation.lock('portrait');
		} else {
			screen.orientation.lock('landscape');
		}
	} else {
		//showtoast('Screen rotation is unsupported on your device.');
		alertMessage('Screen rotation is unsupported on your device.');
	}
/* 
	return;

	switch(screen.orientation.type) {
		case 'portrait-primary': screen.orientation.lock('landscape-primary'); break;
		case 'landscape-primary': screen.orientation.lock('portrait-secondary'); break;
		case 'portrait-secondary': screen.orientation.lock('landscape-secondary'); break;
		case 'landscape-secondary': screen.orientation.lock('portrait-primary'); break;
	} */
}

function fullscreen(force) {
	if(force === undefined) {force = !(document.fullscreenElement || document.mozFullScreenElement);}

	//backwards compatability means i have to write code like this.
	if('mozRequestFullScreen' in document.body) {
		if(force) {
			document.body.mozRequestFullScreen();
		} else {
			document.mozCancelFullScreen();
		}
	} else {
		if(force) {
			document.body.requestFullscreen();
		} else {
			document.exitFullscreen();
		}
	}
}

var showtoastto = 0;
function showtoast(msg) {
	clearTimeout(showtoastto);
	document.getElementById('toast-osd').textContent = msg;
	document.getElementById('toast-osd').style.opacity = 1;
	showtoastto = setTimeout(hidetoast,3000);
}
function hidetoast() {
	document.getElementById('toast-osd').style.opacity = 0;
}

var alertMessageTO = false;
function alertMessage(message,disptime) {
    if(alertMessageTO !== false) {
        clearTimeout(alertMessageTO);
	}
	if(disptime === undefined) {
		disptime = 5000;
	}
    document.getElementById('alertMessage').textContent = message;
    document.getElementById('alertMessage').style.transform = 'translate(0)';
    document.getElementById('alertMessage').style.opacity = 1;
    alertMessageTO = setTimeout(function(){
        alertMessageTO = false;
		document.getElementById('alertMessage').style.transform = null;
		document.getElementById('alertMessage').style.opacity = null;
    },disptime);
}


function timeformat(input) {
    var m = Math.floor(input / 60), s = Math.floor(input % 60);
    if(m < 10) {
        m = '0' + m;
    }
    if(s < 10) {
        s = '0' + s;
	}
    return m + ':' + s;
}

function getave(input) {
	var total = 0;
	for(var i = 0; i < input.length; i++) {
		total += input[i];
	}
	return total / input.length;
}

/* function specweightedave(input) {
	//amplify lower freq
	var na = [];
	for(var i = 0; i < input.length * 0.25; i++) {
		na.push(Math.pow(input[i],(i / input.length) * 10));
	}
	return getave(na);
}
 */

// adapted from https://stackoverflow.com/questions/1255512/how-to-draw-a-rounded-rectangle-on-html-canvas/3368118#3368118
function rectroundtop(x,y,w,h) {
	canvasCtx.beginPath();
	canvasCtx.moveTo(x + (w / 2), y);
	canvasCtx.quadraticCurveTo(x + w, y, x + w, y + (w/2));
	canvasCtx.lineTo(x + w, y + h);
	canvasCtx.lineTo(x, y + h);
	canvasCtx.lineTo(x, y + (w/2));
	canvasCtx.quadraticCurveTo(x, y, x + (w/2), y);
	canvasCtx.closePath();
	canvasCtx.fill();
}

function updatenavbar() {
	switch(curpage) {
		case 0: /* main screen */
			navbar.left.textContent = 'vis. settings';
			navbar.right.textContent = 'menu';
			if(audio.src.paused) {navbar.center.textContent = 'play';} else {navbar.center.textContent = 'pause';}
			break;
		case 1: /* menu */
			navbar.left.textContent = '';navbar.right.textContent = 'back';
			if(menuKsel === 5) { //advert selected
				navbar.center.textContent = 'open advert';
			} else {
				navbar.center.textContent = 'select';
			}
			break;
		case 2: /* settings */
			navbar.left.textContent = 'back';
			navbar.right.textContent = '';
			switch(document.activeElement.dataset.settingtype) {
				case 'color': navbar.center.textContent = 'change'; break;
				case 'number': navbar.center.textContent = ''; break;
				case 'boolean': navbar.center.textContent = 'toggle'; break;
			}
			break;
		case 3: /* color pick */
			navbar.left.textContent = 'cancel'; navbar.right.textContent = '';navbar.center.textContent = 'select'; break;
		case 4: /* about */
			navbar.left.textContent = 'back'; navbar.right.textContent = ''; navbar.center.textContent = ''; break;
		case 5: /* tutorial */
			navbar.left.textContent = ''; navbar.right.textContent = ''; navbar.center.textContent = 'ok'; break;
	}
}